//+------------------------------------------------------------------+
//|                                                  Cmu4_STOMAC.mq4 |
//|                                                             Cmu4 |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Cmu4"
#property link      ""


extern double Lot    = 0.1;                       //  :)


int Napr;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{

   double MA1=iMACD(NULL,0,5,34,1,PRICE_CLOSE, MODE_MAIN,1), 
          MA2=iMACD(NULL,0,5,34,1,PRICE_CLOSE, MODE_MAIN,2),
          MA3=iMACD(NULL,0,5,34,1,PRICE_CLOSE, MODE_MAIN,3);
       
       
   int CountSell=CalculateCountOrder(OP_SELL);
   int CountBuy =CalculateCountOrder(OP_BUY);
       
   if (MA1>MA2 && MA2>MA3 && CountBuy==0)
   {
      Closeall(OP_SELL);
      OrderSend (Symbol(), OP_BUY, Lot, Ask, 5, 0,0);
   }

   if (MA1<MA2 && MA2<MA3 && CountSell==0) {
      Closeall(OP_BUY);
      OrderSend (Symbol(), OP_SELL, Lot, Bid, 5, 0,0);
   }



   return(0);
  }
//+------------------------------------------------------------------+
//------------------------------------------------------------
void Closeall(int OP=-1)
{
   for (int i=OrdersTotal()-1; i>=0; i--) 
   { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) 
      { 
         if(OrderSymbol()==Symbol())
         { 
            if (OrderType()==OP || OP=-1) 
            {
               if(OrderType()==OP_BUY)
                  OrderClose(OrderTicket(),OrderLots(),Bid,3,Red);
               else if(order_type==OP_SELL)
                  OrderClose(OrderTicket(),OrderLots(),Ask,3,Green);
            }
         } 
      }
   }
}


int CalculateCountOrder(int OP=-1){
   int pos;
   int Res=0;
   for (pos=0;pos<OrdersTotal();pos++) {
      if (OrderSelect(pos, SELECT_BY_POS, MODE_TRADES)) {
         if (OrderType()==OP || OP==-1) {
            Res++;
         }
      }
   }
   return(Res);
}